//******************************************
//  : MQ6812_LCD
// 汾     : V 1.00
//      : LCD ʹú
// ע     :
//******************************************

#include "main.h"


const uchar DIG_CODE_fge[16]={  0x05, 0x00, 0x06, 0x02, 0x03, 0x03, 0x07, 0x01,
								0x07, 0x03, 0x07, 0x07, 0x05, 0x06, 0x07, 0x07 };

const uchar DIG_CODE_abcd[16]={	0x0F, 0x06, 0x0B, 0x0F, 0x06, 0x0D, 0x0D, 0x07,
								0x0F, 0x0F, 0x07, 0x0C, 0x09, 0x0E, 0x09, 0x01 };


//*********************************************************************
//    : LCD_Init
//  : OIO,SEG,COM
// ע     :
//*********************************************************************
void LCD_Init(void)
{
//====== ܿ( Enable) ======
    POFFCR2_LCDEN = 1;

//====== 趨 ======
    LCDCR1_DUTY   = 0x05;               //0x05: 1/8 ռգ1/4 ƫѹ
                                        //0x06: 1/8 ռգ1/3 ƫѹ
                                        //0x07: 1/8 ռգ1/2 ƫѹ
    LCDCR1_SLF    = 0x03;               // Fcgck/2^15
    LCDCR2_LDRS   = 1;

    LCDCR3 = 0xf0;                      // Enable SEG_EN[7:4]    
	LCDCR4 = 0x0f;                      // Enable SEG_EN[11:8]    
    LCDCR5 = 0xff;                      // Enable COM_EN[7: 0]
    
    
}


//*********************************************************************
//    : LCD_Start
//  : LCD
// ע     :
//*********************************************************************
void LCD_Start(void)
{
    LCDCR1_EDSP = 1;
}


//*********************************************************************
//    : LCD_Stop
//  : P]LCD
// ע     : ڽ STOP ģʽ֮ǰҪֹͣ LCD ʾմ˳ֹͣ LCD ܣ LCD Ӱ
//            LCD PINΪ͵ƽ⾲̬©硣
//*********************************************************************
void LCD_Stop(void)
{
    LCDCR3 = 0x00;                      // Disable SEG_EN[ 7: 0]
    LCDCR4 = 0x00;                      // Disable SEG_EN[15: 8]
    LCDCR5 = 0x00;                      // Disable COM_EN[7:0]    

    LCDCR1_EDSP   = 0;
    POFFCR2_LCDEN = 0;
	
	// COM0~COM7,SEG4~SEG11 ӦIOܽţΪ͵ƽԱ⾲̬©硣
	// (ע⣺˶δCOM0~COM7,SEG4~SEG11ܽšܽҲͬʽ					
	//  Ϊ͵ƽ⾲̬©硣
	P2DR  &= (~0x18); 
	P4DR  &= (~0xF0); 
	P7DR  &= (~0x7D); 
	P8DR  &= (~0x0C); 
	P9DR  &= (~0x03); 					
	P2CR  |= 0x18; 
	P4CR  |= 0xF0; 
	P7CR  |= 0x7D; 
	P8CR  |= 0x0C; 
	P9CR  |= 0x03; 
}


//*********************************************************************
//    : LCDBUFxx_InitSeq
//  : LCD all on
// ע     : 
//*********************************************************************
void LCDBUFxx_InitSeq(void)
{
    LCDBUF04 = 0xFF;
    LCDBUF05 = 0xFF;                    
    LCDBUF06 = 0xFF;
    LCDBUF07 = 0xFF;
    LCDBUF08 = 0xFF;
    LCDBUF09 = 0xFF;
    LCDBUF10 = 0xFF;
    LCDBUF11 = 0xFF;
}



//*********************************************************************
// 	: Dig_Decode(unsigned char digN,unsigned char Num)
// 	: LCD_digital_display
// ע		:
//*********************************************************************
void Dig_Decode(unsigned char digN,unsigned char Num)
{
	unsigned char NumFGE=0, NumABCD=0, NumMask;

	if( digN/5 )
	{
		NumMask  = 0xf0;
		NumFGE   = DIG_CODE_fge[Num];
		NumABCD  = DIG_CODE_abcd[Num];
	}
	else
	{
		NumMask  = 0x0f;
		NumFGE   = DIG_CODE_fge[Num]  << 4;
		NumABCD  = DIG_CODE_abcd[Num] << 4;
	}

	switch(digN){
		case 1:
			LCDBUF04 &= NumMask;
			LCDBUF05 &= NumMask;
			LCDBUF04 |= NumFGE;
			LCDBUF05 |= NumABCD;
			break;
		case 2:
			LCDBUF06 &= NumMask;
			LCDBUF07 &= NumMask;
			LCDBUF06 |= NumFGE;
			LCDBUF07 |= NumABCD;
			break;
		case 3:
			LCDBUF08 &= NumMask;
			LCDBUF09 &= NumMask;
			LCDBUF08 |= NumFGE;
			LCDBUF09 |= NumABCD;
			break;
		case 4:
			LCDBUF10 &= NumMask;
			LCDBUF11 &= NumMask;
			LCDBUF10 |= NumFGE;
			LCDBUF11 |= NumABCD;
			break;
		case 5:
			LCDBUF04 &= NumMask;
			LCDBUF05 &= NumMask;
			LCDBUF04 |= NumFGE;
			LCDBUF05 |= NumABCD;
			break;
		case 6:
			LCDBUF06 &= NumMask;
			LCDBUF07 &= NumMask;
			LCDBUF06 |= NumFGE;
			LCDBUF07 |= NumABCD;
			break;
		case 7:
			LCDBUF08 &= NumMask;
			LCDBUF09 &= NumMask;
			LCDBUF08 |= NumFGE;
			LCDBUF09 |= NumABCD;
			break;

	}

}

























